Attribute VB_Name = "TimeRoutines"
' VB has some strong limitations on providing accurate times
' This module provides a more accurate way to establish the current time
' using the TimeMilliseconds routine and the Windows API.

' The CalcTime procedure allows you to take into account an offset for
' Universal Time using the Global variable UToffset.
Declare Sub GetLocalTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)
Public UToffset As Double
'Calculate UToffset with:     UToffset = -1 * (TZ / 24)
' were TZ is your timezone in hours from GMT
Public Declare Function GetTimeZoneInformationAny Lib "kernel32" Alias "GetTimeZoneInformation" (Buffer As Any) As Long
'data structure which Windows uses to return the current System Time
Type SYSTEMTIME
        Year As Integer
        Month As Integer
        DayOfWeek As Integer
        Day As Integer
        Hour As Integer
        Minute As Integer
        Second As Integer
        Milliseconds As Integer
End Type
Public TZ As Double
Public AutoTZ As Boolean


Function TimeMilliseconds() As Double
  
  Dim lpSystemTime As SYSTEMTIME
  GetLocalTime lpSystemTime
  TimeMilliseconds = CDbl(DateSerial(lpSystemTime.Year, lpSystemTime.Month, lpSystemTime.Day)) + lpSystemTime.Hour / 24# + lpSystemTime.Minute / (1440#) + lpSystemTime.Second / (86400#) + lpSystemTime.Milliseconds / (86400000#)
  
End Function

Function CalcTime() As Double

CalcTime = TimeMilliseconds + UToffset

End Function

Public Function GetTimeZone() As Double
Dim retval As Long
Dim Buffer(0 To 42) As Long
Const TIME_ZONE_ID_INVALID = &HFFFFFFFF
Const TIME_ZONE_ID_UNKNOWN = 0
Const TIME_ZONE_ID_STANDARD = 1
Const TIME_ZONE_ID_DAYLIGHT = 2
retval = GetTimeZoneInformationAny(Buffer(0))
Select Case retval
    Case TIME_ZONE_ID_INVALID
        GetTimeZone = 0
    Case TIME_ZONE_ID_STANDARD, TIME_ZONE_ID_UNKNOWN
        GetTimeZone = (Buffer(0) + Buffer(21)) / 60
        'or (tzinfo.bias+tzinfo.standardbias)/60
    Case TIME_ZONE_ID_DAYLIGHT
        GetTimeZone = (Buffer(0) + Buffer(42)) / 60
        'or (tzinfo.bias+tzinfo.Daylightbias)/60
    Case Else
        GetTimeZone = 0
End Select
GetTimeZone = -1 * GetTimeZone
End Function
