Attribute VB_Name = "TimeRoutines"
' VB has some strong limitations on providing accurate times
' This module provides a more accurate way to establish the current time
' using the TimeMilliseconds routine and the Windows API.

' The CalcTime procedure allows you to take into account an offset for
' Universal Time using the Global variable UToffset.

Public UToffset As Double
'Calculate UToffset with:     UToffset = -1 * (TZ / 24)
' were TZ is your timezone in hours from GMT

'data structure which Windows uses to return the current System Time
Type SYSTEMTIME
        Year As Integer
        Month As Integer
        DayOfWeek As Integer
        Day As Integer
        Hour As Integer
        Minute As Integer
        Second As Integer
        Milliseconds As Integer
End Type

Declare Sub GetLocalTime Lib "kernel32" (lpSystemTime As SYSTEMTIME)

Function TimeMilliseconds() As Double
  
  Dim lpSystemTime As SYSTEMTIME
  GetLocalTime lpSystemTime
  TimeMilliseconds = CDbl(DateSerial(lpSystemTime.Year, lpSystemTime.Month, lpSystemTime.Day)) + lpSystemTime.Hour / 24# + lpSystemTime.Minute / (1440#) + lpSystemTime.Second / (86400#) + lpSystemTime.Milliseconds / (86400000#)
  
End Function

Function CalcTime() As Double

CalcTime = TimeMilliseconds + UToffset

End Function


